#!/bin/sh

#java="java -client -Xmx1024m -Xms1024m"
java="java"
#java="java -verbose:gc -Xmx1g -Xms1g -XXaggressive"

warmup=2000
duration=5000

for i in 65536; do
r=262144
for o in 1 5; do
for w in 50 100; do
for b in BoostedSkipPQ OptimisticBoostedSkipPQ Boosted OptimisticBoosted; do
:>logs/pq-${b}-i${i}-w${w}-o${o}-r${r}.log
for t in 1 2 4 8 16 32 48 64; do

result=0

for tr in 1 2 3 4 5; do

echo $b " t= " $t " w= " $w " o= " $o " i= " $i " (Trial number " $tr ")"

log=logs/pq-${b}-i${i}-w${w}-o${o}-r${r}.log

if [ ${b} = "Transactional" ]; then
result=`expr $result + $(echo "$(${java} -javaagent:deuceAgent.jar -Dorg.deuce.transaction.contextClass=org.deuce.transaction.tl2.Context -cp deuceTests.jar org.deuce.benchmark.Driver -n ${t} -d ${duration} -w ${warmup} org.deuce.benchmark.intset.Benchmark SkipList -r ${r} -i ${i} -w ${w} -o ${o})" | egrep -e 'Nb iterations        = [^ ]*' -o | cut -d = -f 2)`
else
result=`expr $result + $(echo "$(${java} Driver -n ${t} -d ${duration} -w ${warmup} PQBenchmark ${b} -r ${r} -i ${i} -w ${w} -o ${o})" | egrep -e 'Nb iterations        = [^ ]*' -o | cut -d = -f 2)`
fi

done

result=`expr $result / 25`

echo "result: " $result
echo $t " " $result >> $log

done
done
done
done
done
